		
		
		#include<p16f877a.inc>
		
								;start of general purpose registers
		count	 EQU  0x20		;used in delay routine
		count1	 EQU  0x21		;used in delay routine
		counta	 EQU  0x22		;used in delay routine
		countb	 EQU  0x23
								;used in delay routine
		temp	 EQU  0x24		;temp storage
	    temp1 	 EQU  0x25
        tempold	 EQU  0x2c
		zero	 EQU  0x26
        A  		 EQU  0x27
        
								;pins 16 and 17 are the 2 PWM channels



    	ORG		0x0000
    	NOP						;for boot loader compatibility
    	NOP
    	NOP
		clrf 	zero
    	GOTO	START
    	ORG		0x0010
		call 	Init
START	CALL	Initialise
    							; CALL lcdinit   LCD display is optional.
L0003:
								; 1: Symbol ad_action = ADCON0.GO_DONE 'set new name for A/D conversion start bit
								;       The address of 'ad_action' is 0x1F,2
								; 2: Symbol display = PORTB 'set new name for PORTB used to display the conversion result
								;       The address of 'display' is 0x6
	
								; 4: TRISB = %00000000 'set PORTB pins as outputs
		BSF 	STATUS,RP0
		CLRF 	TRISB
								; 5: TRISA = %111111 'set PORTA pins as inputs
		MOVLW 	0x3F
		MOVWF 	TRISA
								; 6: ADCON0 = 0xc0 'set A/D conversion clock to internal source
		BCF 	STATUS,RP0
		MOVLW 	0xC0
		MOVWF 	ADCON0
								; 7: ADCON1 = 0 'set PORTA pins as analog inputs
		BSF 	STATUS,RP0
		CLRF 	ADCON1
								; 8: High ADCON0.ADON 'turn on A/D converter module
		BCF 	STATUS,RP0
		BSF		ADCON0,0
								; 9: 
								; 10: main: 
L0001:
Loop
		CALL 	ADVAL
								;      Call LCDGO   This is optional so omitted for initial testing.
								; 12: display = ADRESH 'display the result of the conversion
		MOVF 	ADRESH,W
		MOVWF 	PORTB
   		MOVWF 	temp

								; 16: getadresult:  'conversion routine
								; 14: If temp > 127 Then Goto p1 else p2
		MOVF 	0x1e,W
		SUBLW 	0x7F
		BTFSC 	STATUS,C
		GOTO 	L0004
		GOTO 	L0007
L0007:	MOVLW 	0x1F
		ANDWF 	STATUS,F
								; 15: p1: Goto push1
L0002:
	
								; 18: tempold = temp - 127
		MOVF 	0x1E,W
		SUBLW 	0x7F
		MOVWF 	0x2C
		COMF 	0x2C,1

								; 19: 
								; 20: PORTC.0 = 0
		BCF 	0x07,0
								; 21: Goto main
		GOTO	 L00012
								; 22: p2: 
L0004:
								; 23: tempold = 127 - temp
		MOVLW 	0x7f
		SUBWF 	0x1e,W
       
		MOVWF	 0x2C
    	COMF 	0x2C,1

									; 24: PORTC.0 = 1
		BSF 	0x07,0
									; 25: Goto main

L00011
     	movfw 	tempold
     	MOVWF 	temp
  	 	btfsc 	PORTD,7	
     	goto 	pushpull1
     	CALL	SpeedL	;pulse at A
     	goto 	Loop	
pushpull1:
     	CALL	SpeedR
	 	GOTO 	Loop
L00012
     	movfw 	tempold
     	MOVWF 	temp
      	btfsc 	PORTD,7	
      	goto 	pushpull11
      	CALL	SpeedR	;pulse at B
      	goto 	Loop	
pushpull11:  
      	CALL	SpeedL 
	  	GOTO 	Loop

;getpwm:
      ;pwm width continusally increases every T2 time
 ;     	MOVWF 	temp1
  ;    	call 	sine
      					; movfw temp
   ;   	return
Init
        CLRF 	T2CON ; Stop Timer2, Prescaler = 1:1,
    				; Postscaler = 1:1
       	CLRF 	TMR2 ; Clear Timer2 register
        CLRF 	INTCON ; Disable interrupts
        BSF 	STATUS, RP0 ; Bank1
        CLRF 	PIE1 ; Disable peripheral interrupts
        BCF 	STATUS, RP0 ; Bank0
        CLRF 	PIR1 ; Clear peripheral interrupts Flags
        MOVLW 	0x72 ; Postscaler = 1:15, Prescaler = 1:16
        MOVWF 	T2CON ; Timer2 is off
					; BSF T2CON, TMR2ON ; Timer2 starts to increment
        RETURN
					; The Timer2 interrupt is disabled, do polling on the overflow bit
WAIT_t2
	    BTFSS 	PIR1, TMR2IF ; Has TMR2 interrupt occurred?
		GOTO 	WAIT_t2  ; NO, continue loop
						; Timer has overflowed
		BCF 	PIR1, TMR2IF ; YES, clear flag and continue.
		RETURN
Initialise:
    	
    	
    	BANKSEL  TRISC
    	MOVLW    0		;set PORTC as all outputs
    	MOVWF    TRISC
    	BANKSEL  PORTC
	   	MOVF     CCP1CON,W	;set CCP1 as PWM
    	ANDLW    0xF0
    	IORLW    0x0C
    	MOVWF    CCP1CON

    	MOVF     CCP2CON,W	;set CCP2 as PWM
    	ANDLW    0xF0
    	IORLW    0x0C
    	MOVWF    CCP2CON

    	MOVLW    .245		;set highest PWM value
    	BANKSEL  PR2		;over this (127) is permanently on
    	MOVWF    PR2
    	BANKSEL  TMR2

    	MOVF     T2CON,W	;set prescaler to 1
    	ANDLW    0xF8		;PWM at 2500HZ
    	IORLW    0x00
    	MOVWF    T2CON

    	MOVFW    T2CON	;set postscaler to 1
    	ANDLW    0x07
    	IORLW    0x00
    	MOVWF    T2CON
    	
    	CLRF	 CCPR1L		;set PWM to zero
    	CLRF	 CCPR2L

    	BSF      T2CON, TMR2ON	;and start the timer running
		RETURN

SpeedL:				    ;use value in W to set speed (0-127)
    	MOVWF	 temp
		BTFSC	 temp, 7		;if more than 128 cut that 
		ANDLW	 0xfF
    	MOVWF    CCPR1L
     	Clrf 	 CCPR2L
		RETURN

SpeedR:
    	MOVWF	 temp
		BTFSC	 temp, 7
		ANDLW	 0xff
    	MOVWF    CCPR2L
  		clrf     CCPR1L
		RETURN	
   
       
Delay1	movlw	 0x01		;delay .200 ms (4 MHz clock)
d0		movwf	 count1
d1		movlw	 0xE7
		movwf	 counta
		movlw	 0x01
		movwf	 countb
Delay_0	decfsz	 counta, f
		goto	 $+2
		decfsz	 countb, f
		goto	 Delay_0
		decfsz	 count1	,f
		goto	 d1
		return

								; On exit,  result is in temp
;Lcdinit: 						;'initialize LCD module; cursor is blinking
	;	BCF 	0x08,3
	;	BCF 	0x08,1
	;	BCF 	0x08,2
	;	BSF 	STATUS,RP0
	;	BCF 	0x08,3
	;	BCF 	0x08,1
	;	BCF 	0x08,2
	;	CLRF 	0x06
	;	BCF 	STATUS,RP0
	;	MOVLW 	0x02
	;	MOVWF 	R0L
	;	MOVLW 	0x00
	;	MOVWF 	R0H
	;	CALL 	W001
	;	MOVLW 	0x33
	;	CALL 	LC02
	;	MOVLW 	0x33
	;	CALL 	LC02
	;	MOVLW 	0x33
	;	CALL 	LC02
	;	MOVLW 	0x38
	;	CALL 	LC02
	;	MOVLW 	0x0D
	;	CALL 	LC02
	;	MOVLW 	0x01
	;	CALL 	LC02
     ;   return

ADVAL:
						; 17: High ad_action 'start the conversion
		BSF 	ADCON0,2
						; 18: While ad_action 'wait until conversion is completed
L00051:
		BTFSS 	ADCON0,2
		GOTO 	L0006
							; 19: Wend
		GOTO 	L00051
L0006:	MOVLW 	0x1F
		ANDWF 	STATUS,F
								; 20: Return
		RETURN

;ADVAL:
;								; 17: High ad_action 'start the conversion
;		BSF 	0x1F,2
								; 18: While ad_action 'wait until conversion is completed
;L00051:
;		BTFSS 	0x1F,2
;		GOTO 	L00061
								; 19: Wend
;		GOTO 	L00051
;L00061:	MOVLW 	0x1F
;		ANDWF 	STATUS,F
								; 20: Return
;		RETURN
;LCDGO: 
    ;	MOVLW 	0x41
	;	CALL 	LC01
	;	MOVLW 	0x6E
	;	CALL 	LC01
	;	MOVLW 	0x61
	;	CALL 	LC01
	;	MOVLW 	0x6C
	;	CALL 	LC01
	;	MOVLW 	0x6F
	;	CALL 	LC01
	;	MOVLW 	0x67
	;	CALL 	LC01
	;	MOVLW 	0x20
	;	CALL 	LC01
	;	MOVLW 	0x69
	;	CALL 	LC01
	;	MOVLW 	0x6E
	;	CALL 	LC01
	;	MOVLW 	0x70
	;	CALL 	LC01
	;	MOVLW 	0x75
	;	CALL 	LC01
	;	MOVLW 	0x74
	;	CALL 	LC01
	;	MOVLW 	0x20
	;	CALL 	LC01
	;	MOVLW 	0x41
	;	CALL 	LC01
	;	MOVLW 	0x4E
	;	CALL 	LC01
	;	MOVLW 	0x30
	;	CALL 	LC01
								; 27: Lcdcmdout LcdLine2Home 'set cursor at the beginning of line 2
	;	MOVLW 	0xC0
	;	CALL 	LC02
     ;	return
								; 28: Lcdout "V in= ", #an0 'formatted text for line 2
;LL4:	MOVLW 	0xC0
	;	CALL 	LC02
	;
    ;  	MOVLW 	0x56
	;	CALL 	LC01
	;	MOVLW 	0x20
	;	CALL 	LC01
	;	MOVLW 	0x69
	;	CALL 	LC01
	;	MOVLW 	0x6E
	;	CALL 	LC01
	;	MOVLW 	0x3D
	;	CALL 	LC01
	;	MOVLW 	0x20
	;	CALL 	LC01
	;	MOVF 	temp,W
	;	MOVWF 	R2L
		;MOVF 	0x2D,W
 	;	movlw	0
	;	MOVWF 	R2H
	;	CALL 	LC21
	;							; 29: WaitMs 1 'larger value should be used in real device
	;	MOVLW 	0x01
	;	MOVWF 	R0L
	;	CLRF 	R0H
	;	CALL 	W001
     ;  	return

		END



 
